<?php

global $prefixeTable, $conf;
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
if (!defined('IN_ADMIN') or !IN_ADMIN) die('Hacking attempt!');
if (!defined('WHOIS_ONLINE_TABLE')) define('WHOIS_ONLINE_TABLE', $prefixeTable.'whois_online');

function plugin_activate()
{
	global $user;
	$query = "CREATE TABLE IF NOT EXISTS ". WHOIS_ONLINE_TABLE ." (
  `IP` varchar(39) NOT NULL default '',
  `hidden_IP` enum('true','false') NOT NULL default 'false',
  `session_id` varchar(40) NOT NULL,
  `user_id` smallint(5) NOT NULL default '0',
  `username` varchar(100) character set utf8 collate utf8_bin NOT NULL default '',
  `lang` char(2) character set utf8 collate utf8_bin NOT NULL default 'en',
  `country` VARCHAR( 256 ) NOT NULL default '',
  `permanent` enum('true','false') NOT NULL default 'false',
  `last_access` varchar(12) NOT NULL default '',
  `last_elm_ids` varchar(75) NOT NULL default '',
  `last_cat_ids` varchar(75) NOT NULL default '',
  `last_tag_ids` varchar(75) NOT NULL default '',
  `last_sch_ids` varchar(75) NOT NULL default '',
  `first_access_date` varchar(45) NOT NULL default '',
  `last_dates` varchar(110) character set utf8 collate utf8_bin NOT NULL default '',
  `elm_hits` int(10) unsigned NOT NULL default '0',
  `pag_hits` int(10) unsigned NOT NULL default '0',
  `db_timestamp` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`session_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
";
	$result = pwg_query($query);
	if (isset($conf['Whois Online'])) {
		$conf_whois = unserialize($conf['Whois Online']);
		if (!isset($conf_whois['Active'])) $conf_whois['Active'] = true;
		if (!isset($conf_whois['Delete level'])) $conf_whois['Delete level'] = 20;
		if (!isset($conf_whois['Radar limit'])) $conf_whois['Radar limit'] = 25;
		if (!isset($conf_whois['Webmasters'])) $conf_whois['Webmasters'] = 2;
		if (!isset($conf_whois['Administrators'])) $conf_whois['Administrators'] = 2;
		if (!isset($conf_whois['Obsolete limit'])) $conf_whois['Obsolete limit'] = 20;
		if (!isset($conf_whois['Add to Plugins menu'])) $conf_whois['Add to Plugins menu'] = false;
		if (!isset($conf_whois['Add icon to History'])) $conf_whois['Add icon to History'] = true;
		if (!isset($conf_whois['Keep data'])) $conf_whois['Keep data'] = true;
		if (!isset($conf_whois['Default display'])) $conf_whois['Default display'] = true;
		if (!isset($conf_whois['Search id'])) $conf_whois['Search id'] = 0;
		if (!isset($conf_whois['Users'])) 
			$conf_whois['Users'] = Array('max' => 0, 'When' => date('Y-m-d'), 'count' => 0);
		$conf['Whois Online'] = serialize($conf_whois);
	}
	else {
		$conf['Whois Online'] = serialize(Array(
			'Active' => true,
			'Delete level' => 20,
			'Radar limit' => 25,
			'Obsolete limit' => 20,
			'Webmasters' => 2,
			'Administrators' => 2,
			'Search id' => 0,
			'Users' => Array('max' => 0, 'When' => date('Y-m-d'), 'count' => 0),
			'Add to Plugins menu' => false,
			'Add icon to History' => true,
			'Keep data' => true,
			'Default display' => true,
		));
	}
	pwg_query('REPLACE INTO ' . CONFIG_TABLE . " (param,value,comment)
	VALUES ('Whois Online','". $conf['Whois Online'] ."','Whois Online configuration');");
	$conf_whois = unserialize($conf['Whois Online']);
	if (isset($conf_whois['Keep data']) and !$conf_whois['Keep data']) {
		pwg_query('DELETE FROM ' . WHOIS_ONLINE_TABLE);
	}
	list($hits) = mysql_fetch_row(pwg_query('SELECT SUM(hit) FROM '.IMAGES_TABLE.';'));
	$pags = floor($hits * 1.69); /* estimate : 1.69 is a frequent ratio between images hits and pages hits */
	pwg_query('REPLACE INTO ' . WHOIS_ONLINE_TABLE . ' (`IP`, `hidden_IP`, `session_id`, `user_id`,`username`,`lang`,`permanent`,`last_access`,
	`last_elm_ids`, `last_cat_ids`, `last_tag_ids`, `last_sch_ids`,
	`first_access_date`, `last_dates`, `elm_hits`, `pag_hits`)
		VALUES (\'global\', \'true\',\'global\', 0, \'Administrator\', \'--\', \'true\', \''
		. time() .'\', \''. implode(' ',array_fill(0, 12, 0))
		. '\', \''. implode(' ',array_fill(0, 14, 0))
		. '\', \''. implode(' ',array_fill(0, 14, 0))
		. '\', \''. implode(' ',array_fill(0, 14, 0))
		. '\', \'' 
		. date('Y-m-d') . '\', \'\', \'' 
		. $hits . '\', \'' . $pags . '\');');
}

function plugin_deactivate()
{
	global $conf;
	if (isset($conf['Whois Online'])) $conf_whois = unserialize($conf['Whois Online']);
	if (isset($conf_whois['Keep data']) and !$conf_whois['Keep data']) 
		pwg_query('DROP TABLE IF EXISTS ' . WHOIS_ONLINE_TABLE);
}

function plugin_uninstall()
{
	global $conf;
	if (isset($conf['Whois Online'])) $conf_whois = unserialize($conf['Whois Online']);
	if (isset($conf_whois['Keep data']) and !$conf_whois['Keep data']) {
		pwg_query('DELETE FROM ' . CONFIG_TABLE . ' WHERE param = ' . "'Whois Online'");
		pwg_query('DROP TABLE IF EXISTS ' . WHOIS_ONLINE_TABLE);
		unset($conf['Whois Online']);
	}
}
?>